﻿using UnityEngine;
using UnityEngine.UI;

namespace MacGruber
{
    public class RichText : MVRScript
    {
		private TextStorable myTextControl;
		
        public override void Init()
		{
			SetupInfoText(
				"<color=#606060><size=40><b>RichText</b></size>\nEnables Unity RichText when placed on <i>SimpleSign</i> or <i>UIText</i> atoms. This allows <b>bold</b> and <i>italic</i> font as well as individual control of <size=37>fontsize</size> and <color=red>color</color>.</color>",
				300.0f, false
			);
			
			string storableName = string.Empty;
			if (containingAtom.type == "SimpleSign")
				storableName = "Sign";
			else if (containingAtom.type == "UIText")
				storableName = "Text";
			else
				return;
			
			myTextControl = containingAtom.GetStorableByID(storableName) as TextStorable;			
			if (myTextControl != null)
				myTextControl.displayField.supportRichText = true;
		}
		
		private void OnDestroy()
		{
			if (myTextControl != null)
				myTextControl.displayField.supportRichText = false;
		}
		
		public void SetupInfoText(string text, float height, bool rightSide)
		{
			JSONStorableString storable = new JSONStorableString("Info", text);
			UIDynamic textfield = CreateTextField(storable, rightSide);
			textfield.height = height;
		}
    }
}
